<template>
  <div class="transaction-component">
    <div class="new-transaction">
      <h3>Do a new transaction</h3>
      <label
        >From
        <select v-model="transaction.from">
          <option
            v-for="account in accounts"
            :key="account.account"
            :value="account.account"
          >
            {{ account.account }}
          </option>
        </select>
      </label>
      <label
        >To
        <select v-model="transaction.to">
          <option
            v-for="account in accounts"
            :key="account.account"
            :value="account.account"
          >
            {{ account.account }}
          </option>
        </select>
      </label>
      <label
        >Value
        <input type="number" v-model="transaction.value" />
      </label>
      <button @click="newTransaction">Valider</button>
    </div>
    <TransactionDatas :transaction="transactionDatas" />
  </div>
</template>

<script>
import useTransaction from "@/composables/useTransaction.js";
import TransactionDatas from "@/components/TransactionDatas.vue";

export default {
  name: "Transaction",
  components: {
    TransactionDatas,
  },
  props: {
    accounts: {
      type: Array,
      required: false,
      default: [],
    },
  },
  data() {
    return {
      transaction: {
        from: "",
        to: "",
        value: null,
      },
    };
  },
  setup() {
    const { makeNewTransaction, transactionDatas } = useTransaction();

    return {
      makeNewTransaction,
      transactionDatas,
    };
  },
  methods: {
    async newTransaction() {
      await this.makeNewTransaction(this.transaction);
      this.$emit("update-accounts");
    },
  },
};
</script>

<style>
.new-transaction {
  display: flex;
  flex-direction: column;
  align-items: flex-start;
}
label {
  width: stretch;
  display: flex;
  justify-content: space-between;
  align-items: center;
}
select,
input {
  width: 200px;
  margin: 5px 0 5px 10px;
}
option {
  padding: 3px 0;
}
button {
  align-self: center;
}
</style>